lots of fixes, automation for bitfolk
[distro-setup] / system-status
index f50d238b7d6523acc14c65765503894a52811916..c11024bc5ba2c125615beb78c285f6193755c201 100755 (executable)
@@ -7,6 +7,11 @@
 
 if [ -z "$BASH_VERSION" ]; then echo "error: shell is not bash" >&2; exit 1; fi
 
+if [[ $EUID != 1000 ]]; then
+  echo "$0: error, expected to be user 1000"
+  exit 1
+fi
+
 source /a/bin/errhandle/err
 status_file=/dev/shm/iank-status
 
@@ -28,6 +33,7 @@ v() {
     printf "%s\n" "$*"
   fi
 }
+p() { printf "%s\n" "$*"; }
 # log-once COUNT NAME [MESSAGE]
 lo() {
   if type -p ifne &>/dev/null; then
@@ -45,7 +51,6 @@ loday() {
 write-status() {
   chars=("${first_chars[@]}")
 
-
   services=( epanicclean )
   case $HOSTNAME in
     bk|je|li) : ;;
@@ -55,28 +60,26 @@ write-status() {
         btrfsmaintstop
         dynamicipupdate
       )
+      bads=()
+      if systemctl show -p SubState --value ${services[@]} | egrep -v '^(running|)$' &>/dev/null; then
+        for s in ${services[@]}; do
+          if [[ $(systemctl show -p SubState --value $s 2>&1) != running ]]; then
+            bads+=($s)
+          fi
+        done
+        chars+=(MYSERS)
+      fi
+      p ${bads[*]} | lo -240 mysers
       ;;
   esac
 
-  bads=()
-  if systemctl show -p SubState --value ${services[@]} | egrep -v '^(running|)$' &>/dev/null; then
-    for s in ${services[@]}; do
-      if [[ $(systemctl show -p SubState --value $s 2>&1) != running ]]; then
-        bads+=($s)
-      fi
-    done
-    chars+=(MYSERS)
-
-  fi
-  lo -240 mysers ${bads[*]}
-
-  services=(
-    prometheus-node-exporter
-    prometheus-alertmanager
-    prometheus
-  )
   case $HOSTNAME in
     kd)
+      services=(
+        prometheus-node-exporter
+        prometheus-alertmanager
+        prometheus
+      )
       bads=()
       if systemctl show -p SubState --value ${services[@]} | egrep -v '^(running|)$' &>/dev/null; then
         for s in ${services[@]}; do
@@ -86,27 +89,96 @@ write-status() {
         done
         chars+=(PROM)
       fi
-      lo -240 prom ${bads[*]}
+      p ${bads[*]} | lo -240 prom
       ;;
   esac
 
-  # clock us out in timetrap if are idle too long
-  if [[ -e /p/.timetrap.db ]]; then
-    export DISPLAY=:0
-    if type -p xprintidle &>/dev/null && xidle=$(xprintidle 2>/dev/null); then
-      if [[ $xidle == [0-9]* ]]; then
-        sheet=$(sqlite3 /p/.timetrap.db "select sheet from entries where end is NULL;")
-        idle=300000
-        if [[ $sheet == w ]]; then
-          idle=900000
-        fi
-        if [[ $sheet && $xidle -gt $idle ]]; then
-          timetrap out
-        fi
+
+  if [[ -e /a/bin/bash_unpublished/source-state ]]; then
+    # /a gets remounted due to btrbk, ignore error code for file doesnt exist
+    source /a/bin/bash_unpublished/source-state || [[ $? == 1 ]]
+  fi
+  if [[ $MAIL_HOST == "$HOSTNAME" ]]; then
+
+    bouncemsg=
+    glob=(/m/md/bounces/new/*)
+    if [[ -e ${glob[0]} ]]; then
+      chars+=(BOUNCE)
+      bouncemsg="message in /m/md/bounces/new"
+    fi
+    p $bouncemsg | loday -1 bounce
+    # emails without the S (seen) flag. this only checks the last flag,
+    # but its good enough for me.
+    glob=(/m/md/alerts/{new,cur}/!(*,S))
+    if [[ -e ${glob[0]} ]]; then
+      chars+=(A)
+    fi
+
+    glob=(/m/md/daylert/{new,cur}/!(*,S))
+    if [[ -e ${glob[0]} ]]; then
+      chars+=(DAY)
+    fi
+
+    bbkmsg=
+    if [[ $(systemctl is-active btrbk.timer) != active ]]; then
+      chars+=(BTRBK.TIMER)
+      bbkmsg="not enabled"
+    fi
+    p "$bbkmsg" | lo -480 btrbk.timer
+
+    ## check if last snapshot was within an hour
+    vol=o
+    # this section generally copied from btrbk scripts, but
+    # this part modified to speed things up by about half a second.
+    # I'm not sure if its quite as reliable, but it looks pretty safe.
+    # Profiled it using time and also adding to the top of the file:
+    # set -x
+    # PS4='+ $(date "+%2N") '
+    # allow failure in case there are no snapshots yet.
+    # shellcheck disable=SC2012
+    shopt -u nullglob
+    files=(/mnt/root/btrbk/$vol.20*)
+    shopt -s nullglob
+    snaps=()
+    if (( ${#files[@]} )); then
+      snaps=($(ls -1avdr "${files[@]}" 2>/dev/null |head -n1 || : ))
+    fi
+    now=$(date +%s)
+    maxtime=0
+    for s in ${snaps[@]}; do
+      file=${s##*/}
+      t=$(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${file#$vol.}) +%s)
+      if (( t > maxtime )); then
+        maxtime=$t
       fi
+    done
+    snapshotmsg=
+    if (( maxtime < now - 4*60*60 )); then
+      chars+=(OLD-SNAP)
+      snapshotmsg="/o snapshot older than 4 hours"
     fi
-  fi
+    p "$snapshotmsg" | lo -1 old-snapshot
+
+
+    # commented out, only using timetrap retrospectively.
+    # # clock us out in timetrap if are idle too long
+    # if [[ -e /p/.timetrap.db ]]; then
+    #   export DISPLAY=:0
+    #   if type -p xprintidle &>/dev/null && xidle=$(xprintidle 2>/dev/null); then
+    #     if [[ $xidle == [0-9]* ]]; then
+    #       sheet=$(sqlite3 /p/.timetrap.db "select sheet from entries where end is NULL;")
+    #       idle=300000
+    #       if [[ $sheet == w ]]; then
+    #         idle=900000
+    #       fi
+    #       if [[ $sheet && $xidle -gt $idle ]]; then
+    #         timetrap out
+    #       fi
+    #     fi
+    #   fi
+    # fi
 
+  fi
 
   if ip l show tunfsf &>/dev/null; then
     # this is for tracking dns over tls issue, which
@@ -138,26 +210,7 @@ write-status() {
   if [[ $(find /var/mail -type f \! -empty -print -quit) ]]; then
     var_mail_msg="message in /var/mail"
   fi
-  loday -1 var_mail $var_mail_msg
-
-  bouncemsg=
-  glob=(/m/md/bounces/new/*)
-  if [[ -e ${glob[0]} ]]; then
-    chars+=(BOUNCE)
-    bouncemsg="message in /m/md/bounces/new"
-  fi
-  loday -1 bounce $bouncemsg
-  # emails without the S (seen) flag. this only checks the last flag,
-  # but its good enough for me.
-  glob=(/m/md/alerts/{new,cur}/!(*,S))
-  if [[ -e ${glob[0]} ]]; then
-    chars+=(A)
-  fi
-
-  glob=(/m/md/daylert/{new,cur}/!(*,S))
-  if [[ -e ${glob[0]} ]]; then
-    chars+=(DAY)
-  fi
+  p $var_mail_msg | loday -1 var_mail
 
 
   tmp=(/var/local/cron-errors/mailtest-check*)
@@ -180,8 +233,8 @@ write-status() {
   case $HOSTNAME in
     # No point in emailing about the mailq on a host where we don't
     # check email.
-    $MAIL_HOST|bk)
-      loday -120 qlen $qmsg
+    $MAIL_HOST)
+      p $qmsg | loday -120 qlen
       ;;
   esac
 
@@ -273,52 +326,6 @@ write-status() {
     # leave it up to epanic-clean to send email notification
   fi
 
-  if [[ -e /a/bin/bash_unpublished/source-state ]]; then
-    # /a gets remounted due to btrbk, ignore error code for file doesnt exist
-    source /a/bin/bash_unpublished/source-state || [[ $? == 1 ]]
-  fi
-  if [[ $MAIL_HOST == "$HOSTNAME" ]]; then
-    bbkmsg=
-    if [[ $(systemctl is-active btrbk.timer) != active ]]; then
-      chars+=(BTRBK.TIMER)
-      bbkmsg="not enabled"
-    fi
-    lo -480 btrbk.timer $bbkmsg
-
-    ## check if last snapshot was within an hour
-    vol=o
-    # this section generally copied from btrbk scripts, but
-    # this part modified to speed things up by about half a second.
-    # I'm not sure if its quite as reliable, but it looks pretty safe.
-    # Profiled it using time and also adding to the top of the file:
-    # set -x
-    # PS4='+ $(date "+%2N") '
-    # allow failure in case there are no snapshots yet.
-    # shellcheck disable=SC2012
-    shopt -u nullglob
-    files=(/mnt/root/btrbk/$vol.20*)
-    shopt -s nullglob
-    snaps=()
-    if (( ${#files[@]} )); then
-      snaps=($(ls -1avdr "${files[@]}" 2>/dev/null |head -n1 || : ))
-    fi
-    now=$(date +%s)
-    maxtime=0
-    for s in ${snaps[@]}; do
-      file=${s##*/}
-      t=$(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${file#$vol.}) +%s)
-      if (( t > maxtime )); then
-        maxtime=$t
-      fi
-    done
-    snapshotmsg=
-    if (( maxtime < now - 4*60*60 )); then
-      chars+=(OLD-SNAP)
-      snapshotmsg="/o snapshot older than 4 hours"
-    fi
-    lo -1 old-snapshot $snapshotmsg
-  fi
-
   if [[ ! -e $status_file || -w $status_file ]]; then
     if [[ -e /a/bin/bash_unpublished/source-state ]]; then
       cat /a/bin/bash_unpublished/source-state >$status_file
@@ -328,7 +335,6 @@ write-status() {
       echo "ps_char=\"${chars[*]} \$ps_char\"" >>$status_file
     fi
   fi
-
 }
 # use this if we want to do something just once per minute
 first_chars=()